/*
 * $RCSfile$
 * $Revision: 88113 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: mali $          $Locker$
 * $Date: 2008-03-18 13:46:59 +0100 (Wt, 18 mar 2008) $
 * $Log$
 * Revision 1.1  2005/07/07 13:43:17  dario
 * added
 *
 */

#ifndef _REGISTRY_KEY_
#define _REGISTRY_KEY_

#include <windows.h>
#include <string>
#include <vector>

using namespace std;

/**
 * Simple registry manipulation class based on alex implementation
 * used to read/write license machine identifier
 */
class RegistryKey
{
public:
    // Key open modes
    typedef enum {
        OPEN   = 1 << 1,
        CREATE = 1 << 2
    } Mode;
    
    // Access rights
    typedef enum {
        READ = 1 << 1,
        ALL =  1 << 2
    } Access;


    RegistryKey(HKEY key, const string& sSubkey, int modeMask = (OPEN | CREATE), Access access = READ);
    ~RegistryKey(void);

    bool keyNames(vector<string>& keyList);
    bool getValue(const string& sName, string& sValue);
    bool setValue(const string& sName, const string& sValue);
    bool removeSubkey(const string& name);
    
    HKEY getKey()  { return _key;   }
    bool isValid() { return _bValid; }

    const char* getErrorMessage() const { return _errorMessage.c_str(); }

private:    
    bool createRegistryKey(HKEY key, const string& sSubKey);

    bool _bValid;
    HKEY _key;
    
    string _errorMessage;
    void setErrorMessage(const string& error) { _errorMessage = error; }
};

#endif // _REGISTRY_KEY_
