<?xml version="1.0"?>
<!-- in case of any change in xsl/xml file modify all connected xsl and xml files from this package  -->

<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://icl.com/saxon" extension-element-prefixes="saxon">
    <xsl:output method="xml" encoding="UTF-8" indent="yes" />
    <xsl:template match="/ResultsSession">
        <report>
            <xsl:attribute name="tool_name"><xsl:value-of select="@toolName" /></xsl:attribute>
            <xsl:attribute name="tool_version"><xsl:value-of select="@toolVer" /></xsl:attribute>
            <xsl:for-each select="//*[local-name()='StdViol' or local-name()='FlowViol']">
                <weakness>
                    <xsl:attribute name="id"><xsl:value-of select="position()" /></xsl:attribute>
                    <xsl:attribute name="tool_specific_id"><xsl:value-of select="position()" /></xsl:attribute>
                    <name>
                        <!--xsl:attribute name="cweid">1</xsl:attribute-->
                        <xsl:value-of select="@rule" />
                    </name>
                    <location>
                        <xsl:attribute name="line"><xsl:value-of select="@ln" /></xsl:attribute>

                        <xsl:variable name="violPath"><xsl:value-of select="@locFile"/></xsl:variable>
                        <xsl:variable name="violAbsPath" saxon:assignable="yes"><xsl:value-of select="/ResultsSession/Locations/Loc[@loc=$violPath]/@fsPath"/></xsl:variable>
                        
                        <xsl:if test="string-length($violAbsPath) = 0">
                           <saxon:assign name="violAbsPath" select="$violPath"/>
                        </xsl:if>

                        <xsl:attribute name="path"><xsl:value-of select="$violAbsPath"/></xsl:attribute>
                        <!--fragment /-->
                        <!--explanation /-->
                    </location>
                    <grade>
                        <xsl:attribute name="probability">1.0</xsl:attribute>
                        <xsl:attribute name="severity"><xsl:value-of select="@sev" /></xsl:attribute>
                        <xsl:attribute name="tool_specific_rank"><xsl:value-of select="@sev" /></xsl:attribute>
                    </grade>
                    <output>
                        <textoutput>
                            <xsl:value-of select="@msg" />
                        </textoutput>
                        <!--htmloutput /-->
                        <!--xmloutput /-->
                    </output>
                    <!-- not part of tool output -->
                    <xsl:comment>                        
                        &lt;evaluation correctness="" falsepositive="" severity=""&gt;
                            &lt;comments /&gt;
                        &lt;/evaluation&gt;
                    </xsl:comment>
                </weakness>
            </xsl:for-each>
        </report>
    </xsl:template>
</xsl:stylesheet>